
////////////////////////////////////////////
const margin = { top: 100, right: 150, bottom: 200, left: 200 };
const width = 1000;
const height = 1000;
const innerHeight = height - margin.top - margin.bottom;
const innerWidth = width - margin.left - margin.right;
/////////////////////////////////////////////////////

///////////////////////////////////////////////////
// Data function
///////////////////////////////////////////////////
// dataReturn()
const BarChart = () => {
  const [opacityVar, setopacityVar] = useState(0.5);
  const [strokeWidthVar, setstrokeWidthVar] = useState(0.1);
  const [index, setIndex] = useState(0);
  // const data = dataReturn();
  const [display_text_mouseover, setdisplay_text_mouseover] = useState("");

  const xValue = (d: any) => d["Rate of Total Crime against Women (2021)"];
  const yValue = (d: any) => d["State/UT"];
  const yAxisLabel = "City";
  const xAxisLabel = "Crime rate per 1 lakh of women population";
  const xScale = d3
    .scaleLinear()
    .domain([0, d3.max(data, xValue) as any])
    .range([0, innerWidth])
    .nice();
  const yScale = d3
    .scaleBand()
    .domain(data.map(yValue))
    .range([0, innerHeight])
    .padding(0.3);

  ///////////////////////////////////////////////////////////////////////////
  const color = d3.scaleSequential(d3.interpolateBlues(0.8)).domain([0, 300]);
  //////////////////////////////////////////////////////////////////////////
  // Axis//
  const yAxis: any = d3.axisLeft(yScale);
  const yAxisG = d3.select("g");
  yAxisG.call(yAxis);
  //////////////////////////////////////////////////////////////////////////
  const xAxis = d3.axisBottom(xScale);
  const xAxisG = d3.select("g").append("g").call(xAxis);
  xAxisG.attr(
    "transform",
    `translate(0,${innerHeight + margin.top - margin.bottom / 2})`
  );
  ////////////////////////////////////////////////////////////////////////
  //
  //////////////////////////////////////////////////////////////////////
  return (
    <>
      <svg width={width} height={height}>
        <text x={300} y={50} fontSize="18" fontWeight={"bold"}>
          {"Crime against women in the States of India (2021)"}
        </text>
        <text x={380} y={innerHeight + 150} fontSize="16" fontWeight={"normal"}>
          {" "}
          {xAxisLabel}
        </text>
        <g transform={`translate(${margin.left},${margin.top}) scale(1)`}>
          <>
            {data.map((d: any, i: any) => {
              //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

              return (
                <>
                  <rect
                    key={d["Rate of Total Crime against Women (2021)"]}
                    width={
                      xScale(
                        d["Rate of Total Crime against Women (2021)"]
                      ) as any
                    }
                    height={yScale.bandwidth()}
                    x={0 as any}
                    y={yScale(d["State/UT"])}
                    //fill={color(d["Rate of Total Crime against Women (2021)"])}
                    fill="steelblue"
                    stroke={"none"}
                    onClick={() => {
                      setIndex(i);
                      setdisplay_text_mouseover(d["state"]);
                    }}
                    onMouseOver={() => {
                      setIndex(i);
                      // setdisplay_text_mouseover(d["state"]);
                    }}
                    // strokeOpacity={i == index ? 1 : 0}
                    opacity={i == index ? 1 : opacityVar}
                    strokeWidth={i == index ? 3 : strokeWidthVar}
                  />

                  <text
                    key={Math.random()}
                    x={
                      xScale(
                        d["Rate of Total Crime against Women (2021)"]
                      ) as any
                    }
                    y={yScale(d["State/UT"])}
                    dy="0.8em"
                    dx="0.5em"
                    fill="black"
                    fontSize="12"
                    textAnchor="start"
                  >
                    {d["Rate of Total Crime against Women (2021)"]}
                  </text>
                  <Text
                    style={{
                      fontSize: "12px",
                      fill: "black",
                      opacity: 1,
                      fontWeight: "bold",
                    }}
                    key={Math.random() + Math.random() * 300}
                    x={
                      xScale(d["Rate of Total Crime against Women (2021)"]) + 40
                    }
                    y={yScale(d["State/UT"])}
                    text={
                      i === index
                        ? d["State/UT"] +
                          " " +
                          "( " +
                          d["Rate of Total Crime against Women (2021)"] +
                          " )"
                        : null
                    }
                  />
                </>
              );
            })}
          </>
        </g>
      </svg>
    </>
  );
};
export default BarChart;